#include "allegro.h"   
#include "C:\Dev-Cpp\fmodapi374win\api\inc\fmod.h"
#include "C:\Dev-Cpp\fmodapi374win\api\inc\fmod_errors.h"  
#include <string.h>

#define screen_x 320
#define screen_y 200

// font size
#define font_width 32
#define font_height 64

using namespace std;
FMUSIC_MODULE *mod = NULL;
BITMAP *font_bmp;    // the image from the pcx file 
PALETTE font_pal;  // the palette from the pcx file


void Init_Music(void)
{
 	// verify FMOD version
 	if (FSOUND_GetVersion() < FMOD_VERSION)
    {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);         
        allegro_message("Error : You are using the wrong DLL version!  You should be using FMOD %.02f\n", FMOD_VERSION);
        exit(1); // force abort
    }

 	// Initalize Allegro
    if (!FSOUND_Init(32000, 64, 0))
    {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);         
        allegro_message("Fmod Error: %s\n", FMOD_ErrorString(FSOUND_GetError()));
        exit(1); // force abort
    }
    // Set Allegro Message
    mod = FMUSIC_LoadSong("86sec.s3m");
    if (!mod)
    {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);         
        allegro_message("%s\n", FMOD_ErrorString(FSOUND_GetError()));
        exit(1); // force abort
    }
}

void Play_Music(void)
{
    // Play Song!
    FMUSIC_PlaySong(mod);   
}

void Kill_Music(void)
{
    FMUSIC_FreeSong(mod);
    FSOUND_Close();
}

void Init_Font(void)
{
    font_bmp = load_bitmap("bigfont.pcx", font_pal);  // image load 
    set_palette(font_pal);                            // use font palette
}

void Kill_Font(void)
{
    destroy_bitmap(font_bmp);     // release bitmap data
}
void DrawCharacter(int x,int y, char letter)
{
    int i;
    
    // figure out the character mapping for the letter.
    // Credits and greets go to Barzoule for this mapping approach
    char chrmap[]="abcdefghijklmnopqrstuvwxyz0123456789\"'(),.;:+-!?";
    
    // character map, as seen on bigfont.pcx.  
    // char letter is passed by value (not by reference), so I can force upper 
    // case letters to lower case to match the map.
    if(letter>='A' && letter<='Z')
        letter +='a'-'A';

    // do linear search
    for (i=0;i<strlen(chrmap)&&(chrmap[i]!=letter);i++);      

    // Copy character from font_bmp to screen. (if we found a valid one)
    if (i<strlen(chrmap))
      if ((x+font_width)>0 && x<screen_x)     // verify that the x position is visible
        masked_blit(font_bmp, screen,
                i*font_width,0, // font position
                x, y, // letter on screen
                font_width, font_height); // letter dimensions

}

void DrawString(int x,int y,char *message)
{
    int i;
    
    for (i=0;i<strlen(message);i++)
        DrawCharacter(x+i*font_width,y,message[i]);
}

// main program
int main(int argc, char *argv[]) {
   
    int framecount;
    framecount=0;

    allegro_init();        // init Allegro 
	install_keyboard();    // setup allegro keyboard
	
	set_color_depth(8) ;   // 8 bit colour
	if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, screen_x, screen_y, 0, 0)<0)
	{
	    set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);  
	    allegro_message("Failure to init video mode!\n%s\n", allegro_error);
	    exit(1); // force abort
	}
 	
 	// init more stuff  (next phase)
 	Init_Music();
    Init_Font();
    install_timer(); 
    Play_Music();
    
	while ((!key[KEY_ESC])&&(!key[KEY_SPACE])) 
    {
        // DO SOMETHING AMAZING HERE!
        clear_bitmap(screen);
        DrawString((framecount % 640)-320,68,"SCROLLER");
        framecount+=1;
        rest(1); 
    };
    
    
    // de-init more stuff  (next phase)
    Kill_Music();
    Kill_Font();
    remove_timer();     
	return 0;     
}     
END_OF_MAIN();
